﻿#Region "FileHeader"
'    Graphical input is based loosely on
'    http://stackoverflow.com/questions/15579069/graph-nodes-coordinates-evaluation/15580293#15580293
'    https://github.com/High-Core/WPFSamples
'    by Federico Berasategui alias HighCore; originally written in C#
'   
#End Region
Imports System.Windows.Controls.Primitives
Imports Microsoft.Win32
Class MainViewEditor

    Public Sub New()

        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()
        DataContext = New EditorVM

    End Sub

    '**************************************************************************************************************
    ' TODO: Get rid Of the codebehind data And routines! Keywords: ICommand, routed Command
    '**************************************************************************************************************
    Private Sub ThumbNode_Drag(sender As Object, e As DragDeltaEventArgs)
        Dim thumb As Thumb = TryCast(sender, Thumb)
        Dim node As Node = DirectCast(thumb.DataContext, Node)

        node.X += e.HorizontalChange
        node.Y += e.VerticalChange
    End Sub

#Region "DrawingSurface mouse action"
    Private Function GetNodeUnderMouse() As Node
        Dim item As ContentPresenter = TryCast(Mouse.DirectlyOver, ContentPresenter)
        If item Is Nothing Then Return Nothing
        Dim node As Node = TryCast(item.DataContext, Node)
        Return node
    End Function

    Private Sub DrawingSurface_PreviewMouseLeftButtonDown(sender As Object, e As MouseButtonEventArgs)
        Dim vm As EditorVM = TryCast(DataContext, EditorVM)

        If vm.CreatingNewTriangle Then
            Dim node As Node = GetNodeUnderMouse()
            Dim bc As Triangle = TryCast(vm.SelectedObject, Triangle)
            If node IsNot Nothing AndAlso bc IsNot Nothing Then
                bc.Node = node
                node.IsHighlighted = True
                e.Handled = True
            Else
                vm.SelectedObject = Nothing
            End If

        ElseIf vm.CreatingNewRectangle Then
            Dim node As Node = GetNodeUnderMouse()
            Dim opRa As Rectangle = TryCast(vm.SelectedObject, Rectangle)
            If node IsNot Nothing AndAlso opRa IsNot Nothing Then
                opRa.Node = node
                node.IsHighlighted = True
                e.Handled = True
            Else
                vm.SelectedObject = Nothing
            End If
        End If

        If vm.SelectedObject IsNot Nothing Then
            ' Reminder: every new DesignerObject is instanced on (0,0) with flag .IsNew; so it will be removed when right-clicking before it was finally set 
            vm.SelectedObject.IsNew = False
        End If

        vm.CreatingNewNode = False
        vm.CreatingNewTriangle = False
        vm.CreatingNewRectangle = False
    End Sub

    Private Sub DrawingSurface_PreviewMouseRightButtonDown(sender As Object, e As MouseButtonEventArgs)
        Dim vm As EditorVM = TryCast(DataContext, EditorVM)
        vm.CreatingNewNode = False
        vm.CreatingNewTriangle = False
        vm.CreatingNewRectangle = False
        vm.SelectedObject = Nothing
    End Sub

    Private Sub DrawingSurface_PreviewMouseMove(sender As Object, e As MouseEventArgs)
        Dim drawingSurface As ListBox = TryCast(sender, ListBox)
        Dim vm As EditorVM = TryCast(drawingSurface.DataContext, EditorVM)

        If vm.SelectedObject IsNot Nothing Then
            ' here the nodes are drawn
            If TypeOf vm.SelectedObject Is Node AndAlso vm.SelectedObject.IsNew Then
                vm.SelectedObject.X = e.GetPosition(drawingSurface).X
                vm.SelectedObject.Y = e.GetPosition(drawingSurface).Y
            End If
        End If
    End Sub
#End Region

    Private Sub DrawingSurface_KeyDown(sender As Object, e As KeyEventArgs)
        Dim vm As EditorVM = TryCast(DataContext, EditorVM)
        If e.Key = Key.Delete Then
            vm.Delete()
            e.Handled = True
        End If
    End Sub


End Class
