﻿Public Class Node : Inherits DesignerObject

    Private Shared Number As Integer = 0

    Private _nodeNo As Integer
    Public Property NodeNo As Integer
        Get
            Return _nodeNo
        End Get
        Set(value As Integer)
            If value < Number Then
                Number += 1
            End If
            _nodeNo = Number
            _id = "nod" & Number.ToString
            OnPropertyChanged("NodeNo")
        End Set
    End Property

    Private _snappingWidth As Integer = 10
    Private _x As Double = 0
    Public Overrides Property X As Double
        Get
            Return _x
        End Get
        Set(value As Double)
            ' Grid Snapping:
            _x = (Math.Round(value / _snappingWidth)) * _snappingWidth
            OnPropertyChanged("X")
        End Set
    End Property
    Private _y As Double = 0
    Public Overrides Property Y As Double
        Get
            Return _y
        End Get
        Set(value As Double)
            ' Grid Snapping:
            _y = (Math.Round(value / _snappingWidth)) * _snappingWidth
            OnPropertyChanged("Y")
        End Set
    End Property

    Private _isHighlighted As Boolean = False
    Public Property IsHighlighted As Boolean
        Get
            Return _isHighlighted
        End Get
        Set(value As Boolean)
            _isHighlighted = value
            OnPropertyChanged("IsHighlighted")
        End Set
    End Property

    Public Sub New(Optional xCoor As Double = 0, Optional yCoor As Double = 0)
        X = xCoor
        Y = yCoor
        Number += 1
        _NodeNo = Number
        _id = "nod" & Number.ToString
        IsNew = True
    End Sub
End Class