﻿Imports System.ComponentModel
Public Class Rectangle : Inherits DesignerObject


    Private Shared Number As Integer = 0
    Private _no As Integer
    Public Property No As Integer
        Get
            Return _no
        End Get
        Set(value As Integer)
            If value < Number Then
                Number += 1
            End If
            _no = Number
            _id = "rect" & Number.ToString
            OnPropertyChanged("No")
        End Set
    End Property
    ''' <summary>
    ''' in this class the X- and Y-position are not the coordinates of the center of the rectangle; 
    ''' instead these are actually the coordinates for binding onto the canvas (canvas.left, canvas.top)
    ''' </summary>
    Private _bindingPosition As New Point
    Public Overrides Property X As Double
        Get
            Return _bindingPosition.X
        End Get
        Set(value As Double)
            _bindingPosition.X = value
            OnPropertyChanged("X")
        End Set
    End Property
    Public Overrides Property Y As Double
        Get
            Return _bindingPosition.Y
        End Get
        Set(value As Double)
            _bindingPosition.Y = value
            OnPropertyChanged("Y")
        End Set
    End Property

    Private _node As Node
    Public Property Node As Node
        Get
            Return _node
        End Get
        Set(value As Node)
            _node = value
            OnPropertyChanged("Node")
            AddHandler _node.PropertyChanged, AddressOf SetNewBindingPoint
        End Set
    End Property

    Private _height As Double
    Public Property Height As Double
        Get
            Return _height
        End Get
        Set(value As Double)
            _height = value
            OnPropertyChanged("Height")
        End Set
    End Property

    Private _width As Double
    Public Property Width As Double
        Get
            Return _width
        End Get
        Set(value As Double)
            _width = value
            OnPropertyChanged("Width")
        End Set
    End Property

    Public Sub New()
        Number += 1
        No = Number
        _id = "rect" & Number.ToString
        IsNew = True

        Height = 40
        Width = 40
    End Sub

    Private Sub SetNewBindingPoint(sender As Object, e As PropertyChangedEventArgs)
        SetNewBindingValues()
    End Sub
    Private Sub SetNewBindingValues()
        X = Node.X - Width / 2
        Y = Node.Y - Height / 2
    End Sub

End Class
